package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.PtovtaContaMDDAO;
import com.rjconsultores.ventaboletos.entidad.PtovtaContaMD;

@Repository("PtovtaContaMDDAO")
public class PtovtaContaMDHibernateDAO extends GenericHibernateDAO<PtovtaContaMD, Long> implements PtovtaContaMDDAO {
	
	
	@Autowired
	public PtovtaContaMDHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<PtovtaContaMD> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public boolean contemItem(PtovtaContaMD ptovtaContaMD) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("empresaId", ptovtaContaMD.getEmpresaId()));
		c.add(Restrictions.eq("contaId", ptovtaContaMD.getContaId()));
		c.add(Restrictions.eq("puntoventaId", ptovtaContaMD.getPuntoventaId()));
		return !c.list().isEmpty();
	}

}
